// 21.03.2009  -           ,    
// Proteus icq 133575351 lawnmower-man@mail.ru
//      
// :
//       
//         
//     '*'      
//     '='    ( . ),       
#include<stdio.h>
#include<ctype.h>
#include<stack>

//  
struct node_st{
	char op; union{node_st *p1;int value;}; node_st *p2;
	node_st(int v) { 
		op='0';
		value=v;
	}
	node_st(char op,node_st *p1,node_st *p2) {
		this->op=op;
		this->p1=p1;
		this->p2=p2;
	}
};

std::stack<char>op_stack;		//  
std::stack<node_st*>arg_stack;	//  

//   
int GetPriority(char op)
{
	switch(op) {
	case '(':
	case ')': return 0;
	case '=': return 1;
	case '|':
	case '&': return 2;
	case '+':
	case '-': return 3;
	case '*':
	case '/': return 4;
	case '%': return 5;
	}
	return -1;
}

// true     
inline bool isRL(char op1,char op2)
{
	if(op1!=op2) return false;
	switch(op1) {
	case '=': return true;
	}
	return false;
}

//     
bool GetPriority(char op1,char op2)
{
	if(op1=='(') return false;
	int l1=GetPriority(op1);
	int l2=GetPriority(op2);
	if(isRL(op1,op2) && l1==l2) return false;
	return l1<=l2;
}

//     
void Scroll()
{
	node_st *p2=arg_stack.top(); arg_stack.pop();
	node_st *p1=arg_stack.top(); arg_stack.pop();
	arg_stack.push(new node_st(op_stack.top(),p1,p2));
	op_stack.pop();
}

//   ()
void ParseValue(int v)
{
	arg_stack.push(new node_st(v));

}

//  
void ParseOp(char op)
{
	for(;;) {
		if(op_stack.empty()) break;
		if(op_stack.top()=='(') {if(op==')')op_stack.pop();break;}
		if(GetPriority(op,op_stack.top())) Scroll(); else break;
	}
	if(op!=')') op_stack.push(op);
}

//   (    )
void Parse(char *expr)
{
	char sym,old='.'; int value=0;
	do{
		sym=*expr++; putchar(sym);
		if(isdigit(sym)) value=value*10+sym-'0';
		else {
			if(isdigit(old)) {
				ParseValue(value),value=0;
				if(sym=='(') ParseOp('*');
			}
			if(sym) ParseOp(sym);
		}
		old=sym;
	}while(sym);
	while(!op_stack.empty()) Scroll();
}

void Dump(std::string &line,node_st *node,int depth,bool up)
{
	if(node->op=='0') {
		if(depth && up) line[depth-1]='|';
		printf(line.c_str());
		printf("%d\n",node->value);return;
	}
	line+="  ";
	Dump(line,node->p1,depth+2,true);
	line[depth]=node->op;
	if(depth &&  up) line[depth-1]='|';
	printf("%s\n",line.c_str());
	line[depth]=' ';
	if(depth && !up) line[depth-1]=' ';
	Dump(line,node->p2,depth+2,false);
	line.resize(depth);
}

void Show(node_st *node,int parent_priority)
{
	if(node->op=='0') {printf("%d",node->value);return;}
	int priority=GetPriority(node->op);
	if(priority<parent_priority) putchar('(');
	Show(node->p1,priority);
	putchar(node->op);
	Show(node->p2,priority);
	if(priority<parent_priority) putchar(')');
}

//    
void Dump(node_st *node)
{
	std::string line;
	printf("[tree]\n");
	Dump(line,node,0,true);
}

//       
void Show(node_st *node)
{
	printf("[show]\n");
	Show(node,0);
	putchar('\n');
}


int Eval(node_st *node)
{
	if(node->op=='0') return node->value;
	int v1=Eval(node->p1);
	int v2=Eval(node->p2);
	switch(node->op) {
	case '+': return v1+v2;
	case '-': return v1-v2;
	case '*': return v1*v2;
	case '/': return v1/v2;
	case '|': return v1|v2;
	case '&': return v1&v2;
	case '%': return v1%v2;
	case '=': return v2;
	}
	return -1;
}


void main()
{
	int n=0;
	char *expr="7=8=1+1+2(((1*2+3*4)))/2+(71)"; //  =  ,    
	Parse(expr); putchar('\n');
	node_st *res=arg_stack.top();
	Show(res); 
	Dump(res);
	printf("value=%d\n",Eval(res));
	getchar();
}
